var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, ContentChild, TemplateRef } from "@angular/core";
import { FormGroup } from "@angular/forms";
import { DynamicFormControlComponent, DynamicFormControlModel } from "@ng2-dynamic-forms/core";
export var DYNAMIC_FORM_UI_BOOTSTRAP = "BOOTSTRAP";
export var DynamicFormBootstrapComponent = (function (_super) {
    __extends(DynamicFormBootstrapComponent, _super);
    function DynamicFormBootstrapComponent() {
        _super.call(this);
        this.hasSuccessStyles = false;
        this.hasErrorStyles = false;
        this.type = DYNAMIC_FORM_UI_BOOTSTRAP;
    }
    __decorate([
        Input(), 
        __metadata('design:type', FormGroup)
    ], DynamicFormBootstrapComponent.prototype, "controlGroup", void 0);
    __decorate([
        Input(), 
        __metadata('design:type', DynamicFormControlModel)
    ], DynamicFormBootstrapComponent.prototype, "model", void 0);
    __decorate([
        Input(), 
        __metadata('design:type', Boolean)
    ], DynamicFormBootstrapComponent.prototype, "hasSuccessStyles", void 0);
    __decorate([
        Input(), 
        __metadata('design:type', Boolean)
    ], DynamicFormBootstrapComponent.prototype, "hasErrorStyles", void 0);
    __decorate([
        ContentChild(TemplateRef), 
        __metadata('design:type', Object)
    ], DynamicFormBootstrapComponent.prototype, "customTemplate", void 0);
    DynamicFormBootstrapComponent = __decorate([
        Component({
            selector: "dynamic-form-bootstrap-control",
            template: "<div class=\"form-group\" [class.has-error]=\"hasErrorStyles && control.touched && !control.valid\" [class.has-success]=\"hasSuccessStyles && control.touched && control.valid\" [formGroup]=\"controlGroup\" [ngClass]=\"[model.cls.element.container, model.cls.grid.container]\" [ngSwitch]=\"model.type\"><label *ngIf=\"!isCheckbox && model.label\" [attr.for]=\"model.id\" [ngClass]=\"[model.cls.element.label, model.cls.grid.label]\">{{model.label}}</label><div *ngSwitchCase=\"'CHECKBOX'\" [ngClass]=\"model.cls.grid.control\"><div class=\"checkbox\" [class.disabled]=\"model.disabled\"><label [attr.for]=\"model.id\" [ngClass]=\"model.cls.element.label\"><input type=\"checkbox\" [attr.tabindex]=\"model.tabIndex\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [required]=\"model.required\" [value]=\"model.value\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" [(ngModel)]=\"model.value\">{{model.label}}</label></div></div><div *ngIf=\"!isCheckbox\" [ngClass]=\"model.cls.grid.control\"><div *ngSwitchCase=\"'ARRAY'\" [formArrayName]=\"model.id\" [ngClass]=\"model.cls.element.control\"><fieldset *ngFor=\"let idx = index; let groupModel of model.groups\" [formGroupName]=\"idx\"><dynamic-form-bootstrap-control *ngFor=\"let controlModel of groupModel.group\" [controlGroup]=\"control.at(idx)\" [model]=\"controlModel\"></dynamic-form-bootstrap-control><template [ngTemplateOutlet]=\"customTemplate\" [ngOutletContext]=\"groupModel\"></template></fieldset></div><fieldset *ngSwitchCase=\"'GROUP'\" [formGroupName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\"><legend *ngIf=\"model.legend\">{{model.legend}}</legend><dynamic-form-bootstrap-control *ngFor=\"let controlModel of model.group\" [controlGroup]=\"control\" [model]=\"controlModel\"></dynamic-form-bootstrap-control></fieldset><fieldset *ngSwitchCase=\"'CHECKBOX_GROUP'\" [formGroupName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\"><legend *ngIf=\"model.legend\">{{model.legend}}</legend><div *ngFor=\"let item of model.group\" class=\"checkbox\" [class.disabled]=\"model.disabled\"><label [attr.for]=\"item.id\" [ngClass]=\"item.cls.element.label\"><input type=\"checkbox\" [attr.tabindex]=\"model.tabIndex\" [formControlName]=\"item.id\" [name]=\"item.name\" [ngClass]=\"item.cls.element.control\" [required]=\"model.required\" [value]=\"item.value\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" [(ngModel)]=\"item.value\">{{model.label}}</label></div></fieldset><div *ngSwitchCase=\"'INPUT'\" [class.input-group]=\"model.prefix || model.suffix\"><div *ngIf=\"model.prefix\" class=\"input-group-addon\">{{model.prefix}}</div><input class=\"form-control\" [attr.accept]=\"model.accept\" [attr.autoComplete]=\"model.autoComplete\" [attr.list]=\"model.listId\" [attr.max]=\"model.max\" [attr.min]=\"model.min\" [attr.multiple]=\"model.multiple\" [attr.step]=\"model.step\" [attr.tabindex]=\"model.tabIndex\" [autofocus]=\"model.autoFocus\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [spellcheck]=\"model.spellCheck\" [type]=\"model.inputType\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" [(ngModel)]=\"model.value\"><div *ngIf=\"model.suffix\" class=\"input-group-addon\">{{model.suffix}}</div><datalist *ngIf=\"model.list\" [id]=\"model.listId\"><option *ngFor=\"let option of model.list\" [value]=\"option\"></option></datalist></div><fieldset *ngSwitchCase=\"'RADIO_GROUP'\" role=\"radiogroup\" [attr.tabindex]=\"model.tabIndex\" [name]=\"model.name\" (change)=\"onChange($event)\"><legend *ngIf=\"model.legend\">{{model.legend}}</legend><div *ngFor=\"let option of model.options\" class=\"radio\"><label><input type=\"radio\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [value]=\"option.value\" [(ngModel)]=\"model.value\">{{option.label}}</label></div></fieldset><select *ngSwitchCase=\"'SELECT'\" class=\"form-control\" [attr.tabindex]=\"model.tabIndex\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [required]=\"model.required\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" [(ngModel)]=\"model.value\"><option *ngFor=\"let option of model.options\" [attr.name]=\"model.name\" [ngValue]=\"option.value\">{{option.label}}</option></select><textarea *ngSwitchCase=\"'TEXTAREA'\" class=\"form-control\" [attr.tabindex]=\"model.tabIndex\" [cols]=\"model.cols\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [rows]=\"model.rows\" [spellcheck]=\"model.spellCheck\" [wrap]=\"model.wrap\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" [(ngModel)]=\"model.value\"></textarea><span *ngIf=\"model.hint\" class=\"help-block\">{{model.hint}}</span></div><ng-content></ng-content></div>"
        }), 
        __metadata('design:paramtypes', [])
    ], DynamicFormBootstrapComponent);
    return DynamicFormBootstrapComponent;
}(DynamicFormControlComponent));

//# sourceMappingURL=dynamic-form-bootstrap.component.js.map
